## qtmir 0.8.0~git20250305.794fa12

=== src/CMakeLists.txt ===
add_subdirectory(platforms)
add_subdirectory(modules)

=== demos/qtmir-demo-shell/CMakeLists.txt ===
set(DEMO_SHELL qtmir-demo-shell)

include_directories(
    SYSTEM

    ${CMAKE_SOURCE_DIR}/include

    ${MIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}

    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

add_executable(${DEMO_SHELL}
    pointerposition.cpp
    screenwindow.cpp
    screens.cpp
    main.cpp
)

target_link_libraries(
    ${DEMO_SHELL}

    qtmirserver

    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    Qt5::Quick
)

file(GLOB QML_JS_FILES *.qml *.js *.png)

add_custom_target(${DEMO_SHELL}-qmlfiles
                  SOURCES ${QML_JS_FILES})

# install binaries
install(TARGETS ${DEMO_SHELL}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 )

install(FILES
    ${QML_JS_FILES}
    DESTINATION ${QTMIR_DATA_DIR}/${DEMO_SHELL}
)

=== tests/framework/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
    ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
    ${CMAKE_SOURCE_DIR}/src/modules
)

include_directories(
    SYSTEM
    ${APPLICATION_API_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRTEST_INCLUDE_DIRS}

    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
)

set(QTMIR_TEST_PRIVATE_SRC
    fake_application_info.cpp
    fake_mirsurface.cpp
    fake_session.cpp
    mock_application_info.cpp
    mock_main_loop.cpp
    mock_mir_session.cpp
    mock_proc_info.cpp
    mock_prompt_session.cpp
    mock_prompt_session_manager.cpp
    mock_renderable.cpp
    mock_session.cpp
    mock_sessionmap.h
    mock_settings.cpp
    mock_shared_wakelock.cpp
    mock_surface.cpp
    mock_task_controller.cpp
    mock_persistent_surface_store.cpp
    fake_surface.h
    fake_displayconfigurationoutput.h
    qtmir_test.cpp
)

add_library(qtmir-test-framework-static STATIC
    ${QTMIR_TEST_PRIVATE_SRC}
)

target_link_libraries(
    qtmir-test-framework-static

    qtmirapplicationplugin

    ${GTEST_BOTH_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

=== tests/mirserver/CMakeLists.txt ===
add_subdirectory(EventBuilder)
add_subdirectory(QtEventFeeder)
add_subdirectory(URLBuilderDispatcher)
add_subdirectory(Screen)
add_subdirectory(ScreensModel)
add_subdirectory(miral)

=== tests/mirserver/EventBuilder/CMakeLists.txt ===
set(
  EVENT_BUILDER_TEST_SOURCES
  eventbuilder_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
)

include_directories(
  SYSTEM
  ${MIRSERVER_INCLUDE_DIRS}
  ${MIRAL_INCLUDE_DIRS}
)

add_executable(EventBuilderTest ${EVENT_BUILDER_TEST_SOURCES})

target_link_libraries(
  EventBuilderTest
  qtmirserver
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
  ${MIROIL_LIBRARIES}
)

add_test(EventBuilder, EventBuilderTest)

=== tests/modules/Application/CMakeLists.txt ===
set(
  APPLICATION_TEST_SOURCES
  application_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${MIRAL_INCLUDE_DIRS}
  ${MIROIL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Gui_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5DBus_INCLUDE_DIRS}
)

add_executable(application_test ${APPLICATION_TEST_SOURCES})

add_dependencies(application_test qtmir-test-framework-static)

target_link_libraries(
  application_test

  Qt5::Test

  qtmirapplicationplugin

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(Application, application_test)

=== tests/modules/ApplicationManager/CMakeLists.txt ===
set(
  APPLICATION_MANAGER_TEST_SOURCES
  application_manager_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${APPLICATION_API_INCLUDE_DIRS}
  ${MIRAL_INCLUDE_DIRS}
  ${MIROIL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(applicationmanager_test ${APPLICATION_MANAGER_TEST_SOURCES})

add_dependencies(applicationmanager_test qtmir-test-framework-static)

target_link_libraries(
  applicationmanager_test

  Qt5::Test

  qtmirapplicationplugin

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(ApplicationManager applicationmanager_test)

=== tests/modules/General/CMakeLists.txt ===
set(
  GENERAL_TEST_SOURCES
  objectlistmodel_test.cpp
  timestamp_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/timestamp.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/common
  ${CMAKE_SOURCE_DIR}/src/modules
)

add_executable(general_test ${GENERAL_TEST_SOURCES})

target_link_libraries(
  general_test

  Qt5::Gui

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(General general_test)

=== src/platforms/mirserver/miroil/src/CMakeLists.txt ===
set(MIROIL_SRC
    compositor.cpp ${MIROIL_INCLUDE_DIRS}/miroil/compositor.h
    edid.cpp ${qtmir_include}/miroil/edid.h
    persist_display_config.cpp ${MIROIL_INCLUDE_DIRS}/miroil/persist_display_config.h
    display_configuration_policy.cpp ${qtmir_include}/miroil/display_configuration_policy.h
    display_configuration_controller_wrapper.cpp ${MIROIL_INCLUDE_DIRS}/miroil/display_configuration_controller_wrapper.h
    display_listener_wrapper.cpp ${MIROIL_INCLUDE_DIRS}/miroil/display_listener_wrapper.h
    eventdispatch.cpp ${MIROIL_INCLUDE_DIRS}/miroil/eventdispatch.h
    event_builder.cpp ${MIROIL_INCLUDE_DIRS}/miroil/event_builder.h
    input_device.cpp ${MIROIL_INCLUDE_DIRS}/miroil/input_device.h
    input_device_observer.cpp ${MIROIL_INCLUDE_DIRS}/miroil/input_device_observer.h
    mir_server_hooks.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mir_server_hooks.h
    mir_prompt_session.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mir_prompt_session.h
    open_gl_context.cpp ${MIROIL_INCLUDE_DIRS}/miroil/open_gl_context.h
    prompt_session_listener.cpp ${MIROIL_INCLUDE_DIRS}/miroil/prompt_session_listener.h
    prompt_session_manager.cpp ${MIROIL_INCLUDE_DIRS}/miroil/prompt_session_manager.h
    set_compositor.cpp ${MIROIL_INCLUDE_DIRS}/miroil/set_compositor.h
    surface.cpp ${MIROIL_INCLUDE_DIRS}/miroil/surface.h
    ${qtmir_include}/miroil/display_configuration_storage.h
    ${qtmir_include}/miroil/display_id.h
)

if (${mirserver_version} version_less 2.20.0)
    set(MIROIL_SRC
        ${MIROIL_SRC}
        mirbuffer.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mirbuffer.h
    )
endif()

add_library(miroil OBJECT
    ${MIROIL_SRC}
)

target_include_directories(miroil
    PUBLIC  "${MIROIL_INCLUDE_DIRS}" "${qtmir_include}" "${qtmir_include}/qtmir"
    PRIVATE ${MIRAL_INCLUDE_DIRS}
    ${MIRCOMMON_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
)

target_link_libraries(miroil
    PRIVATE
    ${MIRAL_LDFLAGS}
    ${MIRSERVER_LDFLAGS}

    ${EGL_LDFLAGS}
)

=== debian/changelog ===
qtmir (0.8.0~git20250305.794fa12-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Provide required dependencies on libmirserver-dev for building
      e.g. Lomiri without missing-headers-problems in qtmirserver.pc.
  * debian/control:
    + Add D: (libqtmirserver-dev): libmirserver-dev. (Closes: #1099250).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 05 Mar 2025 08:36:53 +0100

qtmir (0.8.0~git20250227.8e417c2-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Support for building against Mir 2.20 and Mir 2.14.1.
  * debian/patches:
    + Drop 0001_rename-content-hub-to-lomiri-content-hub.patch. Applied
      upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 28 Feb 2025 14:46:00 +0100

qtmir (0.8.0~git20240306.de639c3-3) unstable; urgency=medium

  * debian/control:
    + Add to B-D: liblomiri-content-hub-dev (>= 2.0.0).
    + In B-D, switch from pkg-config to pkgconf.
  * debian/patches:
    + Add 0001_rename-content-hub-to-lomiri-content-hub.patch. Adjust to
      renamed (lomiri-)content-hub component.
  * debian/rules:
    + Build with -DWITH_CONTENTHUB=ON.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 08 Sep 2024 22:45:55 +0200

qtmir (0.8.0~git20240306.de639c3-2) unstable; urgency=medium

  * debian/watch:
    + Drop uupdate call.
  * debian/control:
    + Versionize B-D on libprocess-cpp-dev. Require process-cpp (>= 3.0.2)
      (which comes with a fixed SOVERSION_MAJOR).
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 09:59:19 +0200

=== debian/control ===
Source: qtmir
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.6~),
               debhelper-compat (= 13),
               googletest (>= 1.10.0),
               libfontconfig-dev,
               libgles2-mesa-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libgtest-dev,
               liblttng-ust-dev,
               libmiral-dev (>= 3.0),
               libmircommon-dev (>= 2.11.0),
               libmirserver-dev (>= 2.11.0),
               libmtdev-dev,
               libprocess-cpp-dev (>= 3.0.2),
               libqt5sensors5-dev,
               libqtdbusmock1-dev (>= 0.2),
               libqtdbustest1-dev (>= 0.2),
               liblomiri-app-launch-dev,
               libudev-dev,
               liblomiri-api-dev (>= 0.2.0),
               liblomiri-content-hub-dev (>= 2.0.0),
               liblomiri-url-dispatcher-dev,
               libxkbcommon-dev,
               libxrender-dev,
               mir-renderer-gl-dev (>= 2.11.0),
               mirtest-dev (>= 2.11.0),
               libmiroil-dev,
               libmirwayland-dev (>= 2.12.0+dfsg-3~),
               pkgconf,
               pkg-kde-tools,
# lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147
               python3:any,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               quilt,
               valgrind-if-available,
# libmirserver-dev should have brought this dep. Bug lp:1617435
               uuid-dev,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
               libboost-filesystem-dev,
               libboost-system-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/qtmir
Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir

Package: qtmir
Architecture: linux-any
Multi-Arch: same
Breaks: qtmir-android (<< 0.7.0~),
        qtmir-desktop (<< 0.7.0~),
Replaces: qtmir-android (<< 0.7.0~),
          qtmir-desktop (<< 0.7.0~),
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qt platform abstraction (QPA) plugin for a Mir server
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.

Package: qtmir-android
Architecture: armhf arm64
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (mobile, transitional package)
  QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
  It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
  a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for Android-based phones and tablets.
 .
 This is a transitional package. It can safely be removed.

Package: qtmir-desktop
Architecture: linux-any
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (desktop, transitional package)
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for GNU-based desktops.
 .
 This is a transitional package. It can safely be removed.

Package: libqtmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         libmiral-dev (>= 3.0),
         libmiroil-dev,
         libmirserver-dev,
Description: Developer files for QtMir server API
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package contains the library headers for developers.

Package: libqtmirserver2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
      ${shlibs:Depends},
Description: QtMir server API shared library
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 Contains the shared library containing QtMir server API.

Package: qml-module-qtmir
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Provides: lomiri-application-impl,
          lomiri-application-impl-27,
Description: Qt/QML module for Lomiri specific Mir APIs
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 QtMir provides Qt/QML bindings for Mir features that are exposed through the
 qtmir QPA plugin such as Application management (start/stop/suspend/resume)
 and surface management.

Package: qtmir-tests
Section: libdevel
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: littler,
         lttng-tools,
         mir-test-tools,
         qml-module-lomiri-components,
         qml-module-qtmir,
         qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QtMir tests and demos
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package provides benchmark tests and a simple shell and client using the
 QtMir QPA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to be more picky with non-updated .symbols files
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

FLAGS := -DWITH_CONTENTHUB=ON -DWerror=OFF -DWITH_MIR2=on

# Explicitly disable building with Valgrind on architectures without it.
# If valgrind is available or not gets decided via the valgrind-if-available
# virtual package.
ifeq (, $(shell command -v valgrind))
	FLAGS += -DWITH_VALGRIND=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(FLAGS)

override_dh_install:
	#clean gmock/gtest if it built in our build dir
	-rm -f debian/tmp/usr/lib/libgmock*.a debian/tmp/usr/lib/libgtest*.a
	-rm -rf debian/tmp/usr/include/gmock debian/tmp/usr/include/gtest
	dh_install

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## qtmir 0.8.0~git20250316.401819c

=== debian/changelog ===
qtmir (0.8.0~git20250316.401819c-1) unstable; urgency=medium

  [ Alfred Neumayer ]
  * New upstream Git snapshot.
    - src/modules: Keep shared pointers to subsurfaces around as a
      MirSurfaceItem member. Thanks to Alfred Neumayer.
    - src/modules: Only store QSharedPointers when updatePaintNode is
      complete.
    - src/modules: Avoid a race between the Scene Graph and texture
      provider cleanup.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 16 Mar 2025 12:16:50 +0100

qtmir (0.8.0~git20250314.24ef87c-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Set RenderableType to QSurfaceFormat::OpenGLES.
    - Drop server-side decorations Wayland protocol implementation
      (xdgdecoration v1), now provided by Mir 2.20 (also dropping it
      for builds against earlier Mir version as implementation was
      crude and incomplete).
    - Fix subsurface issue with Firefox et al. showing black submenus.
  * debian/{control,rules}:
    + Drop pkgkde_symbolshelper.
  * debian/control:
    + Bump versioned B-Ds on Mir to v2.20.0.
    + Add to B-D: libgbm-dev (reported to Mir maintainer).
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 15 Mar 2025 08:29:05 +0100
